unit schHistoricoMovimientosServer_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable, uDABusinessProcessor, schHistoricoMovimientosClient_Intf;

const
  { Delta rules ids 
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_HISTORICO_MOVIMIENTOSDelta = '{2C024E72-D176-4BD9-9740-772FD40C7E80}';

type
  { IHISTORICO_MOVIMIENTOSDelta }
  IHISTORICO_MOVIMIENTOSDelta = interface(IHISTORICO_MOVIMIENTOS)
  ['{2C024E72-D176-4BD9-9740-772FD40C7E80}']
    { Property getters and setters }
    function GetOldFECHAValue : DateTime;
    function GetOldID_ALMACENValue : Integer;
    function GetOldID_EMPRESAValue : Integer;
    function GetOldNOMBRE_ALMACENValue : String;
    function GetOldID_ARTICULOValue : Integer;
    function GetOldFAMILIAValue : String;
    function GetOldREFERENCIAValue : String;
    function GetOldREFERENCIA_PROVValue : String;
    function GetOldDESCRIPCIONValue : String;
    function GetOldTIPO_MOVIMIENTOValue : String;
    function GetOldCANTIDADValue : Integer;
    function GetOldCAUSAValue : String;

    { Properties }
    property OldFECHA : DateTime read GetOldFECHAValue;
    property OldID_ALMACEN : Integer read GetOldID_ALMACENValue;
    property OldID_EMPRESA : Integer read GetOldID_EMPRESAValue;
    property OldNOMBRE_ALMACEN : String read GetOldNOMBRE_ALMACENValue;
    property OldID_ARTICULO : Integer read GetOldID_ARTICULOValue;
    property OldFAMILIA : String read GetOldFAMILIAValue;
    property OldREFERENCIA : String read GetOldREFERENCIAValue;
    property OldREFERENCIA_PROV : String read GetOldREFERENCIA_PROVValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property OldTIPO_MOVIMIENTO : String read GetOldTIPO_MOVIMIENTOValue;
    property OldCANTIDAD : Integer read GetOldCANTIDADValue;
    property OldCAUSA : String read GetOldCAUSAValue;
  end;

  { THISTORICO_MOVIMIENTOSBusinessProcessorRules }
  THISTORICO_MOVIMIENTOSBusinessProcessorRules = class(TDABusinessProcessorRules, IHISTORICO_MOVIMIENTOS, IHISTORICO_MOVIMIENTOSDelta)
  private
  protected
    { Property getters and setters }
    function GetFECHAValue: DateTime; virtual;
    function GetOldFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetID_ALMACENValue: Integer; virtual;
    function GetOldID_ALMACENValue: Integer; virtual;
    procedure SetID_ALMACENValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    function GetOldID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetNOMBRE_ALMACENValue: String; virtual;
    function GetOldNOMBRE_ALMACENValue: String; virtual;
    procedure SetNOMBRE_ALMACENValue(const aValue: String); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    function GetOldID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetFAMILIAValue: String; virtual;
    function GetOldFAMILIAValue: String; virtual;
    procedure SetFAMILIAValue(const aValue: String); virtual;
    function GetREFERENCIAValue: String; virtual;
    function GetOldREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVValue: String; virtual;
    function GetOldREFERENCIA_PROVValue: String; virtual;
    procedure SetREFERENCIA_PROVValue(const aValue: String); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    function GetOldDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetTIPO_MOVIMIENTOValue: String; virtual;
    function GetOldTIPO_MOVIMIENTOValue: String; virtual;
    procedure SetTIPO_MOVIMIENTOValue(const aValue: String); virtual;
    function GetCANTIDADValue: Integer; virtual;
    function GetOldCANTIDADValue: Integer; virtual;
    procedure SetCANTIDADValue(const aValue: Integer); virtual;
    function GetCAUSAValue: String; virtual;
    function GetOldCAUSAValue: String; virtual;
    procedure SetCAUSAValue(const aValue: String); virtual;

    { Properties }
    property FECHA : DateTime read GetFECHAValue write SetFECHAValue;
    property OldFECHA : DateTime read GetOldFECHAValue;
    property ID_ALMACEN : Integer read GetID_ALMACENValue write SetID_ALMACENValue;
    property OldID_ALMACEN : Integer read GetOldID_ALMACENValue;
    property ID_EMPRESA : Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property OldID_EMPRESA : Integer read GetOldID_EMPRESAValue;
    property NOMBRE_ALMACEN : String read GetNOMBRE_ALMACENValue write SetNOMBRE_ALMACENValue;
    property OldNOMBRE_ALMACEN : String read GetOldNOMBRE_ALMACENValue;
    property ID_ARTICULO : Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property OldID_ARTICULO : Integer read GetOldID_ARTICULOValue;
    property FAMILIA : String read GetFAMILIAValue write SetFAMILIAValue;
    property OldFAMILIA : String read GetOldFAMILIAValue;
    property REFERENCIA : String read GetREFERENCIAValue write SetREFERENCIAValue;
    property OldREFERENCIA : String read GetOldREFERENCIAValue;
    property REFERENCIA_PROV : String read GetREFERENCIA_PROVValue write SetREFERENCIA_PROVValue;
    property OldREFERENCIA_PROV : String read GetOldREFERENCIA_PROVValue;
    property DESCRIPCION : String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property TIPO_MOVIMIENTO : String read GetTIPO_MOVIMIENTOValue write SetTIPO_MOVIMIENTOValue;
    property OldTIPO_MOVIMIENTO : String read GetOldTIPO_MOVIMIENTOValue;
    property CANTIDAD : Integer read GetCANTIDADValue write SetCANTIDADValue;
    property OldCANTIDAD : Integer read GetOldCANTIDADValue;
    property CAUSA : String read GetCAUSAValue write SetCAUSAValue;
    property OldCAUSA : String read GetOldCAUSAValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

implementation

uses
  Variants, uROBinaryHelpers;

{ THISTORICO_MOVIMIENTOSBusinessProcessorRules }
constructor THISTORICO_MOVIMIENTOSBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor THISTORICO_MOVIMIENTOSBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetFECHAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSFECHA];
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetOldFECHAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_HISTORICO_MOVIMIENTOSFECHA];
end;

procedure THISTORICO_MOVIMIENTOSBusinessProcessorRules.SetFECHAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSFECHA] := aValue;
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetID_ALMACENValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSID_ALMACEN];
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetOldID_ALMACENValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_HISTORICO_MOVIMIENTOSID_ALMACEN];
end;

procedure THISTORICO_MOVIMIENTOSBusinessProcessorRules.SetID_ALMACENValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSID_ALMACEN] := aValue;
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetID_EMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSID_EMPRESA];
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetOldID_EMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_HISTORICO_MOVIMIENTOSID_EMPRESA];
end;

procedure THISTORICO_MOVIMIENTOSBusinessProcessorRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSID_EMPRESA] := aValue;
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetNOMBRE_ALMACENValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSNOMBRE_ALMACEN];
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetOldNOMBRE_ALMACENValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_HISTORICO_MOVIMIENTOSNOMBRE_ALMACEN];
end;

procedure THISTORICO_MOVIMIENTOSBusinessProcessorRules.SetNOMBRE_ALMACENValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSNOMBRE_ALMACEN] := aValue;
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetID_ARTICULOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSID_ARTICULO];
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetOldID_ARTICULOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_HISTORICO_MOVIMIENTOSID_ARTICULO];
end;

procedure THISTORICO_MOVIMIENTOSBusinessProcessorRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSID_ARTICULO] := aValue;
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetFAMILIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSFAMILIA];
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetOldFAMILIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_HISTORICO_MOVIMIENTOSFAMILIA];
end;

procedure THISTORICO_MOVIMIENTOSBusinessProcessorRules.SetFAMILIAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSFAMILIA] := aValue;
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetREFERENCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSREFERENCIA];
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetOldREFERENCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_HISTORICO_MOVIMIENTOSREFERENCIA];
end;

procedure THISTORICO_MOVIMIENTOSBusinessProcessorRules.SetREFERENCIAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSREFERENCIA] := aValue;
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetREFERENCIA_PROVValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSREFERENCIA_PROV];
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetOldREFERENCIA_PROVValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_HISTORICO_MOVIMIENTOSREFERENCIA_PROV];
end;

procedure THISTORICO_MOVIMIENTOSBusinessProcessorRules.SetREFERENCIA_PROVValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSREFERENCIA_PROV] := aValue;
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSDESCRIPCION];
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetOldDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_HISTORICO_MOVIMIENTOSDESCRIPCION];
end;

procedure THISTORICO_MOVIMIENTOSBusinessProcessorRules.SetDESCRIPCIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSDESCRIPCION] := aValue;
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetTIPO_MOVIMIENTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSTIPO_MOVIMIENTO];
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetOldTIPO_MOVIMIENTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_HISTORICO_MOVIMIENTOSTIPO_MOVIMIENTO];
end;

procedure THISTORICO_MOVIMIENTOSBusinessProcessorRules.SetTIPO_MOVIMIENTOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSTIPO_MOVIMIENTO] := aValue;
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetCANTIDADValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSCANTIDAD];
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetOldCANTIDADValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_HISTORICO_MOVIMIENTOSCANTIDAD];
end;

procedure THISTORICO_MOVIMIENTOSBusinessProcessorRules.SetCANTIDADValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSCANTIDAD] := aValue;
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetCAUSAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSCAUSA];
end;

function THISTORICO_MOVIMIENTOSBusinessProcessorRules.GetOldCAUSAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_HISTORICO_MOVIMIENTOSCAUSA];
end;

procedure THISTORICO_MOVIMIENTOSBusinessProcessorRules.SetCAUSAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_HISTORICO_MOVIMIENTOSCAUSA] := aValue;
end;


initialization
  RegisterBusinessProcessorRules(RID_HISTORICO_MOVIMIENTOSDelta, THISTORICO_MOVIMIENTOSBusinessProcessorRules);

end.
